Fix test for cleanup failure in t7300 on Windows
[git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 LC_ALL=C
9 PAGER=cat
10 TZ=UTC
11 export LANG LC_ALL PAGER TZ
12 EDITOR=:
13 VISUAL=:
14 unset GIT_EDITOR
15 unset AUTHOR_DATE
16 unset AUTHOR_EMAIL
17 unset AUTHOR_NAME
18 unset COMMIT_AUTHOR_EMAIL
19 unset COMMIT_AUTHOR_NAME
20 unset EMAIL
21 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
22 unset GIT_AUTHOR_DATE
23 GIT_AUTHOR_EMAIL=author@example.com
24 GIT_AUTHOR_NAME='A U Thor'
25 unset GIT_COMMITTER_DATE
26 GIT_COMMITTER_EMAIL=committer@example.com
27 GIT_COMMITTER_NAME='C O Mitter'
28 unset GIT_DIFF_OPTS
29 unset GIT_DIR
30 unset GIT_WORK_TREE
31 unset GIT_EXTERNAL_DIFF
32 unset GIT_INDEX_FILE
33 unset GIT_OBJECT_DIRECTORY
34 unset SHA1_FILE_DIRECTORIES
35 unset SHA1_FILE_DIRECTORY
36 GIT_MERGE_VERBOSITY=5
37 export GIT_MERGE_VERBOSITY
38 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
39 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
40 export EDITOR VISUAL
41
42 # Protect ourselves from common misconfiguration to export
43 # CDPATH into the environment
44 unset CDPATH
45
46 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
47         1|2|true)
48                 echo "* warning: Some tests will not work if GIT_TRACE" \
49                         "is set as to trace on STDERR ! *"
50                 echo "* warning: Please set GIT_TRACE to something" \
51                         "other than 1, 2 or true ! *"
52                 ;;
53 esac
54
55 # Each test should start with something like this, after copyright notices:
56 #
57 # test_description='Description of this test...
58 # This test checks if command xyzzy does the right thing...
59 # '
60 # . ./test-lib.sh
61
62 [ "x$TERM" != "xdumb" ] &&
63         [ -t 1 ] &&
64         tput bold >/dev/null 2>&1 &&
65         tput setaf 1 >/dev/null 2>&1 &&
66         tput sgr0 >/dev/null 2>&1 &&
67         color=t
68
69 while test "$#" -ne 0
70 do
71         case "$1" in
72         -d|--d|--de|--deb|--debu|--debug)
73                 debug=t; shift ;;
74         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
75                 immediate=t; shift ;;
76         -h|--h|--he|--hel|--help)
77                 help=t; shift ;;
78         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
79                 verbose=t; shift ;;
80         -q|--q|--qu|--qui|--quie|--quiet)
81                 quiet=t; shift ;;
82         --no-color)
83                 color=; shift ;;
84         --no-python)
85                 # noop now...
86                 shift ;;
87         *)
88                 break ;;
89         esac
90 done
91
92 if test -n "$color"; then
93         say_color () {
94                 case "$1" in
95                         error) tput bold; tput setaf 1;; # bold red
96                         skip)  tput bold; tput setaf 2;; # bold green
97                         pass)  tput setaf 2;;            # green
98                         info)  tput setaf 3;;            # brown
99                         *) test -n "$quiet" && return;;
100                 esac
101                 shift
102                 echo "* $*"
103                 tput sgr0
104         }
105 else
106         say_color() {
107                 test -z "$1" && test -n "$quiet" && return
108                 shift
109                 echo "* $*"
110         }
111 fi
112
113 error () {
114         say_color error "error: $*"
115         trap - exit
116         exit 1
117 }
118
119 say () {
120         say_color info "$*"
121 }
122
123 test "${test_description}" != "" ||
124 error "Test script did not set test_description."
125
126 if test "$help" = "t"
127 then
128         echo "$test_description"
129         exit 0
130 fi
131
132 exec 5>&1
133 if test "$verbose" = "t"
134 then
135         exec 4>&2 3>&1
136 else
137         exec 4>/dev/null 3>/dev/null
138 fi
139
140 test_failure=0
141 test_count=0
142 test_fixed=0
143 test_broken=0
144
145 die () {
146         echo >&5 "FATAL: Unexpected exit with code $?"
147         exit 1
148 }
149
150 trap 'die' exit
151
152 test_tick () {
153         if test -z "${test_tick+set}"
154         then
155                 test_tick=1112911993
156         else
157                 test_tick=$(($test_tick + 60))
158         fi
159         GIT_COMMITTER_DATE="$test_tick -0700"
160         GIT_AUTHOR_DATE="$test_tick -0700"
161         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
162 }
163
164 # You are not expected to call test_ok_ and test_failure_ directly, use
165 # the text_expect_* functions instead.
166
167 test_ok_ () {
168         test_count=$(expr "$test_count" + 1)
169         say_color "" "  ok $test_count: $@"
170 }
171
172 test_failure_ () {
173         test_count=$(expr "$test_count" + 1)
174         test_failure=$(expr "$test_failure" + 1);
175         say_color error "FAIL $test_count: $1"
176         shift
177         echo "$@" | sed -e 's/^/        /'
178         test "$immediate" = "" || { trap - exit; exit 1; }
179 }
180
181 test_known_broken_ok_ () {
182         test_count=$(expr "$test_count" + 1)
183         test_fixed=$(($test_fixed+1))
184         say_color "" "  FIXED $test_count: $@"
185 }
186
187 test_known_broken_failure_ () {
188         test_count=$(expr "$test_count" + 1)
189         test_broken=$(($test_broken+1))
190         say_color skip "  still broken $test_count: $@"
191 }
192
193 test_debug () {
194         test "$debug" = "" || eval "$1"
195 }
196
197 test_run_ () {
198         eval >&3 2>&4 "$1"
199         eval_ret="$?"
200         return 0
201 }
202
203 test_skip () {
204         this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
205         this_test="$this_test.$(expr "$test_count" + 1)"
206         to_skip=
207         for skp in $GIT_SKIP_TESTS
208         do
209                 case "$this_test" in
210                 $skp)
211                         to_skip=t
212                 esac
213         done
214         case "$to_skip" in
215         t)
216                 say_color skip >&3 "skipping test: $@"
217                 test_count=$(expr "$test_count" + 1)
218                 say_color skip "skip $test_count: $1"
219                 : true
220                 ;;
221         *)
222                 false
223                 ;;
224         esac
225 }
226
227 test_expect_failure () {
228         test "$#" = 2 ||
229         error "bug in the test script: not 2 parameters to test-expect-failure"
230         if ! test_skip "$@"
231         then
232                 say >&3 "checking known breakage: $2"
233                 test_run_ "$2"
234                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
235                 then
236                         test_known_broken_ok_ "$1"
237                 else
238                     test_known_broken_failure_ "$1"
239                 fi
240         fi
241         echo >&3 ""
242 }
243
244 test_expect_success () {
245         test "$#" = 2 ||
246         error "bug in the test script: not 2 parameters to test-expect-success"
247         if ! test_skip "$@"
248         then
249                 say >&3 "expecting success: $2"
250                 test_run_ "$2"
251                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
252                 then
253                         test_ok_ "$1"
254                 else
255                         test_failure_ "$@"
256                 fi
257         fi
258         echo >&3 ""
259 }
260
261 test_expect_code () {
262         test "$#" = 3 ||
263         error "bug in the test script: not 3 parameters to test-expect-code"
264         if ! test_skip "$@"
265         then
266                 say >&3 "expecting exit code $1: $3"
267                 test_run_ "$3"
268                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
269                 then
270                         test_ok_ "$2"
271                 else
272                         test_failure_ "$@"
273                 fi
274         fi
275         echo >&3 ""
276 }
277
278 # This is not among top-level (test_expect_success | test_expect_failure)
279 # but is a prefix that can be used in the test script, like:
280 #
281 #       test_expect_success 'complain and die' '
282 #           do something &&
283 #           do something else &&
284 #           test_must_fail git checkout ../outerspace
285 #       '
286 #
287 # Writing this as "! git checkout ../outerspace" is wrong, because
288 # the failure could be due to a segv.  We want a controlled failure.
289
290 test_must_fail () {
291         "$@"
292         test $? -gt 0 -a $? -le 128
293 }
294
295 # Most tests can use the created repository, but some may need to create more.
296 # Usage: test_create_repo <directory>
297 test_create_repo () {
298         test "$#" = 1 ||
299         error "bug in the test script: not 1 parameter to test-create-repo"
300         owd=`pwd`
301         repo="$1"
302         mkdir "$repo"
303         cd "$repo" || error "Cannot setup test environment"
304         "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
305         error "cannot run git init -- have you built things yet?"
306         mv .git/hooks .git/hooks-disabled
307         cd "$owd"
308 }
309
310 test_done () {
311         trap - exit
312
313         if test "$test_fixed" != 0
314         then
315                 say_color pass "fixed $test_fixed known breakage(s)"
316         fi
317         if test "$test_broken" != 0
318         then
319                 say_color error "still have $test_broken known breakage(s)"
320                 msg="remaining $(($test_count-$test_broken)) test(s)"
321         else
322                 msg="$test_count test(s)"
323         fi
324         case "$test_failure" in
325         0)
326                 # We could:
327                 # cd .. && rm -fr trash
328                 # but that means we forbid any tests that use their own
329                 # subdirectory from calling test_done without coming back
330                 # to where they started from.
331                 # The Makefile provided will clean this test area so
332                 # we will leave things as they are.
333
334                 say_color pass "passed all $msg"
335                 exit 0 ;;
336
337         *)
338                 say_color error "failed $test_failure among $msg"
339                 exit 1 ;;
340
341         esac
342 }
343
344 # Test the binaries we have just built.  The tests are kept in
345 # t/ subdirectory and are run in trash subdirectory.
346 PATH=$(pwd)/..:$PATH
347 GIT_EXEC_PATH=$(pwd)/..
348 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
349 unset GIT_CONFIG
350 unset GIT_CONFIG_LOCAL
351 GIT_CONFIG_NOSYSTEM=1
352 GIT_CONFIG_NOGLOBAL=1
353 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
354
355 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
356 export GITPERLLIB
357 test -d ../templates/blt || {
358         error "You haven't built things yet, have you?"
359 }
360
361 if ! test -x ../test-chmtime; then
362         echo >&2 'You need to build test-chmtime:'
363         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
364         exit 1
365 fi
366
367 . ../GIT-BUILD-OPTIONS
368
369 # Test repository
370 test=trash
371 rm -fr "$test"
372 test_create_repo $test
373 cd "$test"
374
375 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
376 for skp in $GIT_SKIP_TESTS
377 do
378         to_skip=
379         for skp in $GIT_SKIP_TESTS
380         do
381                 case "$this_test" in
382                 $skp)
383                         to_skip=t
384                 esac
385         done
386         case "$to_skip" in
387         t)
388                 say_color skip >&3 "skipping test $this_test altogether"
389                 say_color skip "skip all tests in $this_test"
390                 test_done
391         esac
392 done